<?php
if ( !defined( 'IN_CMS' ) ) {
    exit();
}

use PHPMailer\PHPMailer\SMTP;

\IoC::resolve( 'eventmediator' )->attach( 'before_route', function( FastRoute\RouteCollector $r, $request, $response ) {
    $r->get( 'smtp/settings', 'plugins\\smtp\\controllers\\SettingsController@index' );
    $r->post( 'smtp/settings', 'plugins\\smtp\\controllers\\SettingsController@update' );
    return true;
} );

\IoC::resolve( 'eventmediator' )->attach( 'before_send_email', function( $mail ) {

    $settings = \IoC::resolve( 'settings' );
    $mail->isSMTP();
    //$mail->SMTPDebug = SMTP::DEBUG_SERVER;
    $mail->Host = $settings['smtp.host'];
    $enableAuthentication = $settings['smtp.enable_authentication'];
    $mail->SMTPAuth = $enableAuthentication;
    if ( !empty( $settings['smtp.encryption_mode'] ) ) {
        $mail->SMTPSecure = $settings['smtp.encryption_mode'];
    }      
    if ( $enableAuthentication ) {
        $mail->Username = $settings['smtp.username'];
        $mail->Password = $settings['smtp.password'];
        $mail->Port = $settings['smtp.port'];
    }
    return true;
    
} );

$logger = \IoC::resolve( 'logger' );
$logger->info( 'Plugin smtp initialized.' );
